;
; keygen source for WiteG crackme - 4
;  written by elfz, elfz@laacz.lv
;
; Sure  enough,  I know that there is such feature as PROCEDURES, and all of this
; could  be  nicely  divided  into  procedures  instead  of  plain,  more-or-less
; straightforward text. Also, I'm very much informed that you can write "xor eax,
; eax"  instead  of "mov eax, 0" and "or edx, edx" instead of "cmp edx, 0". Yet I
; believe that "mov eax, 0" is more beautiful and understandable. I'm not running
; for smallest code possible here; I just want it to look nice.
;
; Ah,  and  keygen  was  first  written in C++ with assembly inlines, while I was
; cracking  it.  It  was  converted  to pure assembly  just after all was running
; nice.
;

.data
include tables.inc
caption   db '{elfZ keygen for WiteG crackme 4}', 0
pref_user db 'your old grandma', 0
work      db 68h dup (?) ; serial work-time storage; we'll work with this
.code

calc_ser proc

    
    ; without this, the keygen would crash under w2k
     
        pushad
    
    
    ; nicely clean out the serial space

        lea     edi, work
        mov     eax, 0
        mov     ecx, 18h
        rep     stosd




    ; prepare fucc1 reversing table

        mov     ebx, 0
        mov     eax, 0
@@:     mov     fucc1_table[eax], bl
        add     eax, 0adh
        and     eax, 0ffh
        inc     bl
        ja      @b





    ; store username into its correct place

        lea     esi, usr
        mov     ecx, usr_len
        lea     edi, work + 48h
        rep     movsb





    ; encrypt the user name

        lea     esi, work + 48h
        lea     edi, greetz
        
        mov     ecx, 4
        
enc_loop:
        mov     edx, [esi]
        mov     eax, [esi + 4]
        push    ecx
        mov     ecx, 0

@@:     movzx   ebx, sectab [ecx]
        add     ebx, edi
        push    eax
        add     eax, [ebx] 
        lea     ebx, enctab
        xlat
        add     ebx, 100h
        ror     eax, 8
        xlat
        add     ebx, 100h
        ror     eax, 8
        xlat
        add     ebx, 100h
        ror     eax, 8
        xlat
        rol     eax, 3
        xor     eax, edx
        pop     edx
        inc     ecx
        cmp     ecx, 20h
        jne     @b

        mov     [esi], edx
        mov     [esi + 4], eax

        add esi, 8
        add edi, 0dh
        pop ecx
        loop enc_loop




    ; transfer the encrypted user name to offset 0

        lea     esi, work + 48h
        lea     edi, work
        movsd
        movsd
        movsd
        movsd
        movsd
        movsd




    ; do the rotation

        lea     edi, work
        mov     ebx, 180h ; too lazy to write right rotator,
                          ; so let's use ripped left rotator and adjust
                          ; the rotation times ;p
        movzx   eax, byte ptr work[4eh]
        sub     ebx, eax

rot_loop:
        shl     byte ptr [edi+17h], 1
        mov     ecx, 17h

@@:     rcl     byte ptr [ecx+edi-1], 1
        loop    @b

        adc     byte ptr [edi+17h], 0
        dec     ebx
        jnz     rot_loop





    ;
    ;
    ; main encode: 6 dwords
    ;
    ;

        lea     esi, work
        lea     edi, work + 48h

        mov     ecx, 6

main_encode_loop:
        push    ecx
        movzx   edx, byte ptr [edi] ; how many times will the value @ esi be fucced
        mov     eax, [esi] ; eax = destination value; we need to get source

sub_encode_loop:
        push edx

    
    
    ; reverse bits
            
        mov ebx, eax
        mov ecx, 32
@@:     rol ebx, 1
        rcr eax, 1
        loop @b


        
        cmp edx, 0    ; if times=0 we don't do any fucc2 reversing
        je skip_fucc




    ; fucc2 reversing


        movzx   ecx, byte ptr [edi]
        sub     ecx, edx
        inc     ecx

f2r:    push    ecx
        mov     ebx, 0  ; result
        mov     edx, 0  ; last stored bit
        mov     ecx, 32 ; loop 32 bits

@@:     shl     eax, 1
        jc      need_1
        cmp     edx, 0
        jne     set_1   ; last bit was 1, need to get 0
                        ; << last bit was 0, need to get 0
set_0:  clc
        rcl     ebx, 1
        mov     edx, 0
        jmp     cont

need_1: cmp     edx, 0
        jne     set_0   ; last bit was 1, need to get 1
                        ; << last bit was 0, need to get 1
set_1:  stc
        rcl     ebx, 1
        mov     edx, 1

cont:   loop    @b

        mov     eax, ebx
        pop     ecx
        loop    f2r


skip_fucc:

    ; fucc1 reversing


        lea ebx, fucc1_table
        xlat
        mov cl, al
        
        shr eax, 8
        xlat
        ror ecx, 8
        mov cl, al

        shr eax, 8
        xlat
        ror ecx, 8
        mov cl, al

        shr eax, 8
        xlat
        ror ecx, 8
        mov cl, al

        ror ecx, 8

        mov eax, ecx
        

        pop     edx
        dec     dl      ; 1 - 256 times, not 0 - 255
        jnz     sub_encode_loop


        mov     [esi], eax
        add     esi, 4
        inc     edi
        pop     ecx
        dec     ecx     ; jump too far for "loop" :(
        jnz     main_encode_loop





    ; last fix: math checksum routine

        lea     esi, work + 48h
        lea     edi, work + 18h
        mov     ecx, 2

@@:     push    ecx
        lodsd
        and     eax, 3fffffffh
        mov     ebx, eax         ; R1 = ebx
        lodsd
        and     eax, 3fffffffh
        mov     ecx, eax         ; R2 = ecx
        lodsd
        and     eax, 3fffffffh
        mov     edx, eax         ; R3 = edx

        mov     eax, ecx         ; C1 = R2 - R1 + R2 - R1 + R3;
        add     eax, ecx
        sub     eax, ebx
        sub     eax, ebx
        add     eax, edx
        stosd
    
        mov     eax, ebx         ; C2 = R1 + R2 - R3;
        add     eax, ecx
        sub     eax, edx
        stosd

        mov     eax, ecx         ; C3 = R2 + R2 - R3;
        add     eax, ecx
        sub     eax, edx
        stosd

        mov     eax, ecx         ; C4 = R2 + R3 - R1;
        add     eax, edx
        sub     eax, ebx
        stosd

        mov     eax, ebx         ; C5 = R1 + R1 - R3;
        add     eax, ebx
        sub     eax, edx
        stosd

        mov     eax, ecx         ; C6 = R2 + R2 - R1;
        add     eax, ecx
        sub     eax, ebx
        stosd
        
        pop ecx
        loop @b




    ; convert serial to human-readable form

        lea     esi, work
        lea     edi, ser
        mov     ecx, 60h
@@:
        lodsb
        mov     edx, eax
        ror     eax, 4
        and     eax, 0Fh
        aam
        db      0d5h, 11h ;  aad 11
        add     eax, 30h
        stosb
        mov     eax, edx
        and     eax, 0Fh
        aam
        db      0d5h, 11h ;  aad 11
        add     eax, 30h
        stosb
        loop    @b


    ; without this, the keygen would crash under w2k

        popad

        retn


calc_ser endp
